use clap::{arg, command, ArgMatches};

pub fn get_args() -> ArgMatches {
    command!()
        .about("Patch the frontmatter of markdown files")
        .arg(arg!([markdown] "Markdown File").required(true))
        .arg(arg!(-p --patch <PATCH> "Apply JSON Patch file. If set to '-' read from stdin").required(false).conflicts_with("merge"))
        .arg(arg!(--merge <FILE> "Merge Markdown frontmatter. If set to '-' read from stdin").required(false).conflicts_with("patch"))
        .arg(arg!(-a --add "Only patch add operations").required(false).conflicts_with("merge"))
        .arg(arg!(-m --modify "Only patch modify operations").required(false).conflicts_with("merge"))
        .arg(arg!(-d --delete "Only patch delete operations").required(false).conflicts_with("merge"))
        .arg(arg!(-v --verbose "Print out what changes will be made to the document").required(false))
        .arg(arg!(-n --dryrun "Dont modify the input file. Only print what would be done").required(false))
        .arg(arg!(-o --output <OUTPUT> "Write patched file to output path. Dont modify the input file directly. If set to '-' output to stdout"))
        .arg(arg!(--notest "Ignore tests in JSON Patch files").conflicts_with("merge"))
        .arg(
            arg!(-x --exclude <JSONPATH>... "Exclude json path from patch")
                .required(false)
                .conflicts_with("keys"),
        )
        .arg(
            arg!(-k --keys <JSONPATH>... "Only include the specified json paths in patch")
                .required(false)
                .conflicts_with("exclude"),
        )
        .get_matches()
}
